//     Author: Maurizio Loreti, aka MLO or (HAM) I3NOO
//     Work:   University of Padova - Department of Physics
//             Via F. Marzolo, 8 - 35131 PADOVA - Italy
//     Phone:  +39 (049) 827-7216   FAX: +39 (049) 827-7102
//     EMail:  loreti@pd.infn.it
//     WWW:    http://www.pd.infn.it/~loreti/mlo.html
//
// -------------------------------------------------------------------
// $Id: signals.hh,v 1.1 2002/11/28 17:50:59 loreti Exp $
// -------------------------------------------------------------------
// A procedure that deals with the Unix signals, designed to
// encapsulate the different implementations found on several
// operating systems - and to present to the user a consistent
// interface.
// -------------------------------------------------------------------

#ifndef SIGNALS_HH_
#define SIGNALS_HH_

extern "C" {
  #include <signal.h>
}

// Defines "sigFunction" as a shortcut for a function taking a const
// int and returning void

typedef void sigFunction(const int);

namespace MySignal {
  sigFunction * mySignal(const int, sigFunction *);
}

#endif // SIGNALS_HH_
