/* $Id: sockhelp.h,v 1.2 2001/10/18 08:14:29 loreti Exp $ */

#if !defined(SOCKHELP_H_)
#define SOCKHELP_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <limits.h>

#include <sys/types.h>
#include <signal.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>

#if defined(__linux__)
  #include <bits/sigaction.h>
  #include <bits/sigset.h>
#endif
#if defined(__sun__) || defined(__sgi__)
  #include <sys/signal.h>
#endif

/**
 | - Define "sigFunction" as a shortcut for a function taking a const
 |   int and returning void;
 | - define "SA" as a shortcut for "struct sockaddr".
**/

typedef void sigFunction(const int);
typedef struct sockaddr SA;

/**
 | ANSI prototypes
**/

int             atoport(const char *, const char *);
struct in_addr *atoaddr(const char *s);
int             get_connection(const int, const unsigned short, int *);
int             make_connection(const char *, const int, const char *);
int             sock_read(const int, char *, const size_t);
int             sock_write(const int, const char *, const size_t);
int             sock_gets(const int, char *, const size_t);
int             sock_puts(const int, const char *);
sigFunction    *my_signal(const int, sigFunction *);

#endif /* SOCKHELP_H_ */
