/* $Id: toyclient.c,v 1.1 1999/12/03 09:52:24 loreti Exp $ */

#include <stdio.h>
#include <unistd.h>

#include "sockhelp.h"

#define BUFFER_LEN 1024

int main(
  int   argc,
  char *argv[]
) {
  int  sock;
  int  connected = 1;
  char buffer[BUFFER_LEN];

/**
 | - Checks the command line arguments;
 | - ignores SIGPIPE (see the comments in "toyserver.c");
 | - establishes a connection with the server.
**/

  if (argc != 3) {
    fprintf(stderr, "Usage:\t%s <host> <port>\n", argv[0]);
    fputs("\t<host> is the machine which is running the server program\n",
          stderr);
    fputs("\t<port> is the port where the server is listening on.\n", stderr);
    return EXIT_FAILURE;
  }

  if (my_signal(SIGPIPE, SIG_IGN) == SIG_ERR) {
    perror("sigaction(SIGPIPE)");
    return EXIT_FAILURE;
  }

  if ((sock = make_connection(argv[2], SOCK_STREAM, argv[1])) == -1) {
    fprintf(stderr, "make_connection failed.\n");
    return EXIT_FAILURE;
  }

/**
 | - Gets the 'welcome' message from the server (the '-1' is due to
 |   the terminating line feed received from the server);
 | - loops until the detection of an EOF in input, or a connection error.
**/

  sock_gets(sock, buffer, BUFFER_LEN-1);

  do {
    fprintf(stdout, "Server: %s\n",buffer);

    fprintf(stdout, "Client: ");
    if (fgets(buffer, BUFFER_LEN, stdin) == 0   ||   buffer[0] == '\0') {
      connected = 0;
    } else {
      sock_puts(sock, buffer);

      if (sock_gets(sock, buffer, BUFFER_LEN-1) == -1) {
        connected = 0;
      }
    }
  } while (connected);

  fprintf(stdout, "<CLOSED>\n");
  close(sock);
  return EXIT_SUCCESS;
}
